#include <iostream>
#include "naglowki.h" // Txtburn-c++
//The documentation about license is in license-gpl-2.0.txt
//This program was written in 2012 by Michał "mucha090" Kubicki

/* jest to główny plik tego programu, w nim mamy:
- zmienne programu
- główne menu
- konfiguracja ustawień programu (jako funkcja)
- wypalanie i rippowanie płyt audiocd (dwie osobne funckje)
- o programie
cała reszta jest rozproszona po plikach (jak i w/w :P)
ten plik posiada na chwile obecną ok. 166 linijek kodu
*/
using namespace std;

#ifndef __WIN32__
#include <locale.h>
#include <langinfo.h>
#include <string.h>
char terminal_charset[64];
#endif

int main(int argc, char * argv[])
{

#ifndef __WIN32__
    setlocale(LC_ALL,"");
    strcpy(terminal_charset,nl_langinfo(CODESET));
    if (!strcasecmp(terminal_charset,"UTF-8")) terminal_charset[0]=0;
    else strcat(terminal_charset,"//TRANSLIT");
#endif
	switch (argc)
	{
	case 1:
	{
    string txtburn_conf = txtburn_cfg_file();
    // sprawdza gdzie ma zapisać plik konfiguracyjny txtburn.cfg
    // albo w folderze config (on będzie wykorzystany tylko gdy w nim znajdować się będzie plik portable
    // jeśli nie to skorzysta on z folderu ~/.txtburn/)
    string apps = portable_apps();
    // w/w sprawdza z jakiego folderu mają być wykorzystane zew programy (tylko linux)
    // ex. albo z bin-linux będzie korzystał program albo z tego systemowego
    string default_folder = txtburn_default_folder();
    // w/w sprawdza jaki ma być domyślny folder do ustawień, etc.

    int iMAXSPEED = 4; // maksymalna prędkość wypalania
    int iBUFFERSIZE = 14; // bufor wypalania

    bool czyDobrze;

    stringstream string2int, string2int2;
    stringstream int2string, int2string2;
    // w/w zmienne są do przetrzymywania wartości int, i zostaną wykorzystane do przekazania i vice versa
    // ich do zmiennych std::string MAXSPEED i std::string BUFFERSIZE
    kontenery_zmiennych_str zmienneTxtburn;
    zmienneTxtburn.devname = devdvd;
    zmienneTxtburn.devcdda = devaudiocd;
//---------------------------------------------------------------//cdda2mp3dir, cdda2oggdir, cdda2wavdir, wav2mp3dir, wav2oggdir, DEVCDDA
//---------------------------------------------------------------//
    zmienneTxtburn.inDIRECTORY = default_folder + weDIRECTORY ;
    zmienneTxtburn.outDIRECTORY = default_folder + wyDIRECTORY ;
    zmienneTxtburn.VOLNAME = "txtburn";
    zmienneTxtburn.ISONAME = "txtburn.iso";
//---------------------------------------------------------------//
//---------------------------------------------------------------//
    zmienneTxtburn.cdda2mp3dir = default_folder +  Cdda2mp3dir ;
    zmienneTxtburn.cdda2oggdir = default_folder +  Cdda2oggdir ;
    zmienneTxtburn.cdda2wavdir = default_folder +  Cdda2wavdir ;
    zmienneTxtburn.wav2mp3dir = default_folder +  Wav2mp3dir ;
    zmienneTxtburn.wav2oggdir = default_folder +  Wav2oggdir ;
    zmienneTxtburn.DEVICE = devdev + zmienneTxtburn.devname + "";
    zmienneTxtburn.DEVCDDA = devdev + zmienneTxtburn.devcdda + "";
    zmienneTxtburn.DIRIISO = zmienneTxtburn.outDIRECTORY + slashslash + zmienneTxtburn.ISONAME + "";
    int2string << iMAXSPEED;
    zmienneTxtburn.MAXSPEED = int2string.str();
    int2string2 << iBUFFERSIZE;
    zmienneTxtburn.BUFFERSIZE = int2string2.str();
    zmienneTxtburn.nic = " ";
//---------------------------------------------------------------//
//---------------------------------------------------------------//
// sprawdzenie czy wczytać trzeba zmienne z pliku cfg czy użyć ich domyslnych wartości
    ifstream txtburn_cfg (txtburn_conf.c_str());
    string line;
    if (txtburn_cfg.is_open())// kilka linijek niżej została opisana cała procedura
    {
        if (txtburn_cfg.good())
            txtburn_cfg.seekg(-2, ios::end);
        getline (txtburn_cfg, line);
        txtburn_cfg.close();
    }
    else if (!(txtburn_cfg.is_open()))
        line = "1";
    if (line=="0")
    {
        file2string(zmienneTxtburn);
        stringstream string2int(zmienneTxtburn.MAXSPEED);
        stringstream string2int2(zmienneTxtburn.BUFFERSIZE);
        string2int >> iMAXSPEED;
        string2int2 >> iBUFFERSIZE;
        cout << PL("Ustawienia zostały pomyślnie wczytane :)\n");
    }
// poczatek_prog, tutaj program się "przedstawia" użytkownikowi i tworzy niezbędne pliki/foldery
    line.clear();                      // tutaj zaczyna się pobieranie wartości z pliku
    string firstrun_str =  default_folder + "firstrun.txt";
    ifstream firstrun (firstrun_str.c_str());// i przekazywanie jej do zmiennej line
    if (firstrun.is_open())   // jeśli plik jest otwarty...
    {
        if (firstrun.good())    // i ma się dobrze:P...
            getline (firstrun,line);// to pobierze się wartość do zmiennej line
        firstrun.close(); // zamknie się plik
    }
    else if (!(firstrun.is_open()))  // a jeśli pliku nie uda się otworzyć to...
        line = "0"; // wartość zmiennej line jest równa 0
    if ((line == "0")) // no a tutaj jeśli zmienna line jest równa 0 to uruchomi się funkcja poczatek_prog
        poczatek_prog(zmienneTxtburn);

#ifdef __WIN32__
    int scrclronce = 1;
#endif

    do
    {
//główne menu
#ifdef __WIN32__
        if (scrclronce == 1) clrscr();
        scrclronce = 0;
#endif
        cout << PL("\nWitaj w programie Txtburn, \nprawdopodobnie najmniejszej na świecie aplikacji do nagrywania płyt.\n")
             << PL("Co teraz zamierzasz zrobić? Wybierz jedną z poniższych opcji:\n")
             << PL("1 - Wypalanie płyt CD/DVD\n")
             << PL("2 - Rippowanie płyt CD-Audio\n")
             << "3 - Ustawienia programu\n"
             << "4 - O programie\n"
             << PL("5 - Wyjście z programu\n\n");
        int menu;
        cin >> menu;
        czyDobrze = cin.good();
        cin.clear();
        cin.ignore(1000, '\n');
		blokada(czyDobrze, menu);

        switch (menu)
        {
            // wypalanie płyt DVD/CD
        case 1:
            wypalanie(zmienneTxtburn);
            cout << PL("Główne menu\n");
            break;// koniec menu do wypalania płyt DVD/CD
            //rippowanie audiocd
        case 2:
            rippowanie(zmienneTxtburn);
            cout << PL("Główne menu\n");
            break; //koniec menu do rippowania płyt AudioCD i konwersji plików audio
            // konfiguracja programu
        case 3:
            ustaw_programu(iMAXSPEED, iBUFFERSIZE, zmienneTxtburn);
            cout << PL("Główne menu\n");
            break; //koniec menu edycji
            // o programie
        case 4:
            about_Txtburn();
            cout << PL("Główne menu\n");
            break; // koniec informacji o programie
            // Program exit
        case 5:
            clrscr();
            cout << "Do widzenia :-)\n";
            return 0;
            break; // end of program exit
            // default info
        default:
            clrscr();
            cout << "\tError 404. Page not found.\n";
            break; // end of default info
        }
    }
    while (!((cin.fail())));
    return 0;
	}
default:
{//TODO *zrobić parametry do programu*	
/*argc = 0;const char * value1 = "-v"; char ** value = const_cast<char *> (value1);
if ((argv[1]==value)||(argv[2]=="-v")||(argv[argc++] == "-v"))*/ 
about_Txtburn();
exit(1);
break;
}
}
}
